/**********************************************************************
** Detail
**
** Display module information
**
** Copyright (C) 2002, Michael Lauer
**                    mickey@tm.informatik.uni-frankfurt.de
**                    http://www.Vanille.de
**
** Based on ProcessDetail by Dan Williams <williamsdr@acm.org>
**
** This file may be distributed and/or modified under the terms of the
** GNU General Public License version 2 as published by the Free Software
** Foundation and appearing in the file LICENSE.GPL included in the
** packaging of this file.
**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
**********************************************************************/
//nukin change QTextView to QTextBrowser

#include "detail.h"

Detail::Detail( QWidget* parent,  const char* name, WFlags )
: ZBaseDialog( parent, name, WStyle_ContextHelp )
{
    QVBoxLayout *layout = new QVBoxLayout( this );
	
    detailView = new QTextBrowser( this );
    detailView->setFrameStyle( QFrame::NoFrame );
    //detailView->setTextFormat( PlainText );  //can't read html formated text
	detailView->setHScrollBarMode(QScrollView::AlwaysOff);
	
    ZPushButton *closeButton = new ZPushButton( this, 3, -1, -1 );
    closeButton->setGeometry( ZGlobal::getCSTRect() );
    closeButton->setText(tr("Close"));
	
    layout->addWidget( detailView );
    layout->addWidget( closeButton );
	
    connect( closeButton, SIGNAL(clicked()), this, SLOT(close()) );
}

Detail::~Detail()
{
}

