/*
 Name : LCD SETUP
 By : Meng Zhong Die Wu
 Compile : MOTO-E6-IDE
 Time : 2009.07.25
 EMail : 497699123@qq.com
*/
#ifndef LCDINFO_H
#define LCDINFO_H
#include "config.h"
#if HAVE_MODULE(MODULE_LCD)
#define FBIOSETBKLIGHT          0x4619
#define FBIOGETBKLIGHT          0x461A
#define FBIOSETBRIGHTNESS       0x461B 
#define FBIOGETBRIGHTNESS       0x461C 
#include <qwidget.h>

class QLabel;
class QRadioButton;
class UTIL_Slider;
class QSpinBox;
class UTIL_PushButton;
class QComboBox;

class Q_EXPORT LcdInfo : public QWidget
{
	Q_OBJECT
public :
    LcdInfo( QWidget *parent = 0, const char *name = 0, WFlags f = 0 );
    ~LcdInfo();
public slots:
    void setLightSensord();
    void setLcdSleepTime(int);
    void setBklightBrightness(int);
    void setBklightBrightness();
private :
    int get_lightsensord_pid();
    int getLcdSleepTime();
	int getBklightBrightness();
private :
	QComboBox *timeCombo;
	QLabel *DOTime;
    QString String;
	QRadioButton *neverBtn, *defaultBtn, *cuzBtn;
	QLabel* label;
    UTIL_Slider* slider;
    QSpinBox *cuzTimeSpin, *minBtS, *maxBtS, *cameraBtS, *detectIntS;
    UTIL_PushButton *switchBt;
};
#endif //MODULE_LCD
#endif //LCDINFO_H

