/**********************************************************************
** Copyright (C) 2000 Trolltech AS.  All rights reserved.
**
** 
**
** This file is part of Qtopia Environment.
**
** This file may be distributed and/or modified under the terms of the
** GNU General Public License version 2 as published by the Free Software
** Foundation and appearing in the file LICENSE.GPL included in the
** packaging of this file.
**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
** See http://www.trolltech.com/gpl/ for GPL licensing information.
**
** Contact info@trolltech.com if any conditions of this licensing are
** not clear to you.
**
**********************************************************************/

/**********************************************************************
**Meng Zhong Die Wu Add OverClock
**nukin
**add: app/sys cpu usage, CPU frequency 
**draw 曲线 
**
**********************************************************************/
#include <qwallpaper.h>
#include "load.h"

#include <ezxpm.h>
#include <ZMessageBox.h>
//#include <ZPushButton.h>
#include <ZSetManager.h>


#include <stdlib.h>
#include <stdio.h>
#include <qfile.h>
#include <qdir.h>
#include <qlayout.h>
#include <qlabel.h>
#include <qpainter.h>
//#include <qpixmap.h>
#include <qtextstream.h>
#include <qtimer.h>
#include <qwhatsthis.h>

LoadInfo::LoadInfo( QWidget *parent, const char *name, WFlags f )
    : QWidget( parent, name, f )
{
    QVBoxLayout *vb = new QVBoxLayout( this, 6 );

    QString cpuInfo = "<font color=#feeeff>Intel XScale-PXA27x rev 7 (v5l)</font>";
	if ( !cpuInfo.isNull() )
		vb->addWidget( new QLabel( cpuInfo, this ) );
	cpuGraph=new Load( this );
    vb->addWidget( cpuGraph, 100 );

    QHBoxLayout *hb = new QHBoxLayout( 0, 0, 2 );
    vb->addLayout( hb );
    QLabel *l = new QLabel( this );
    l->setPixmap( makeLabel( red ) );
    hb->addWidget( l );
    app = new QLabel( tr("App usage: %"), this );
    hb->addWidget( app, 1 );

    hb = new QHBoxLayout( 0, 0, 2 );
    vb->addLayout( hb );
    l = new QLabel( this );
    l->setPixmap( makeLabel( green ) );
    hb->addWidget( l );
    sys = new QLabel( tr("System usage: %"), this );
    hb->addWidget( sys, 1 );
    

    //Meng Zhong Die Wu Add OverClock 
    QString info = "";
    if ( QFile::exists( "/tmp/apmd" ) ){
        QFile bp( "/tmp/OverClock" );
        if ( bp.open( IO_ReadOnly ) ){
           QTextStream bs( &bp );
           info = bs.readLine();
        }
       bp.close();
    }
    hb = new QHBoxLayout( 0, 0, 2 );
    vb->addLayout( hb );
    frequency = new QLabel( tr("CPU frequency: ") + info, this );
    hb->addWidget( frequency , 1 );

    QHBoxLayout *hb1 = new QHBoxLayout( 0, 0, 2 );
    vb->addLayout( hb1 );

   QPushButton* Send_Normal = new QPushButton( this, "SendButton" );
   Send_Normal->setFixedHeight( 25 );
   Send_Normal->setText( tr("Normal") );
   connect( Send_Normal, SIGNAL( clicked() ), this, SLOT( slotSend_Normal() ) );
   hb1->addWidget( Send_Normal );

   QPushButton* Send_416 = new QPushButton( this, "SendButton" );
   Send_416->setFixedHeight( 25 );
   Send_416->setText( "416" );
   connect( Send_416, SIGNAL( clicked() ), this, SLOT( slotSend_416() ) );
   hb1->addWidget( Send_416 );

    QPushButton* Send_520 = new QPushButton( this, "SendButton" );
    Send_520->setFixedHeight( 25 );
    Send_520->setText( "520" );
    connect( Send_520, SIGNAL( clicked() ), this, SLOT( slotSend_520() ) );
    hb1->addWidget( Send_520 );

    QPushButton* Send_624 = new QPushButton( this, "SendButton" );
    Send_624->setFixedHeight( 25 );
    Send_624->setText( "624" );
    connect( Send_624, SIGNAL( clicked() ), this, SLOT( slotSend_624() ) );
    hb1->addWidget( Send_624 );

    vb->addStretch(20);
	
	QTimer *timer = new QTimer( this );
    connect( timer, SIGNAL(timeout()), SLOT(timeout()) );
    timer->start( 2000 );

    QWhatsThis::add( this, tr( "This page shows how much this device's processor is being used.\n Meng Zhong Die Wu Added switching frequency!\nPush the button to make CPU at that frequency!\nCPU can adjust frequency smartly in normal mode" ));
}
void LoadInfo::slotSend_Normal()
{
	int bt=getBklightBrightness();
	printf("bt:%d\n",bt);
	system("echo 312 > /tmp/OverClock");
	system("start-stop-daemon --stop -s KILL --name apmd");
	if(system("start-stop-daemon --start --exec /usr/bin/apmd -b")==0);
	{
		//PM_setupBklightBrightness( bt );				//does not work here!
		ZMessageBox::timerMessage(this,NULL,tr("Frequency now: Normal (312/207/103 MHz)"),1);
	}
	PM_setupBklightBrightness( bt );
}
void LoadInfo::slotSend_416()
{
	int bt=getBklightBrightness();
	printf("bt:%d\n",bt);
	system("echo 416 > /tmp/OverClock");
	if(system("/bin/cp -f " + QDir::currentDirPath() + "/bin/apmd_416 " + "/tmp/apmd" )!=0) qDebug("/bin/cp -f " + QDir::currentDirPath() + "/bin/apmd_416 " + "/tmp/apmd");
	system("start-stop-daemon --stop -s KILL --name apmd");
	if(system("start-stop-daemon --start --exec /tmp/apmd -b")==0);
	{
		//PM_setupBklightBrightness( bt );
		ZMessageBox::timerMessage(this,NULL,tr("Frequency now: 416MHz"),1);
	}
	PM_setupBklightBrightness( bt );
}
void LoadInfo::slotSend_520()
{
	int bt=getBklightBrightness();
	printf("bt:%d\n",bt);
	system("echo 520 > /tmp/OverClock");
	if(system("/bin/cp -f " + QDir::currentDirPath() + "/bin/apmd_520 " + "/tmp/apmd" )!=0) qDebug("/bin/cp -f " + QDir::currentDirPath() + "/bin/apmd_416 " + "/tmp/apmd");
	system("start-stop-daemon --stop -s KILL --name apmd");
	if(system("start-stop-daemon --start --exec /tmp/apmd -b")==0);
	{
		//PM_setupBklightBrightness( bt );
		ZMessageBox::timerMessage(this,NULL,tr("Frequency now: 520 MHz"),1);
	}
	PM_setupBklightBrightness( bt );
}
void LoadInfo::slotSend_624()
{
	int bt=getBklightBrightness();
	printf("bt:%d\n",bt);
	system("echo 624 > /tmp/OverClock");
	if(system("/bin/cp -f " + QDir::currentDirPath() + "/bin/apmd_624 " + "/tmp/apmd" )!=0) qDebug("/bin/cp -f " + QDir::currentDirPath() + "/bin/apmd_416 " + "/tmp/apmd");
	system("start-stop-daemon --stop -s KILL --name apmd");
	if(system("start-stop-daemon --start --exec /tmp/apmd -b")==0);
	{
		//PM_setupBklightBrightness( bt );
		ZMessageBox::timerMessage(this,NULL,tr("Frequency now: 624 MHz"),1);
	}
	PM_setupBklightBrightness( bt );
}

int LoadInfo::getBklightBrightness()
{
  int BklightBrightness;
  SETUP_SET_Manager mgr( "/ezx_user/download/appwrite/setup/ezx_system.cfg", false);
  mgr.getSettingInfo("SYS_SYSTEM_SET", "Brightness", BklightBrightness ,25);
  return BklightBrightness;
}

QPixmap LoadInfo::makeLabel( const QColor &col )
{
    int h = fontMetrics().height();
    QPixmap pm( 18, h-4 );
    QPainter p( &pm );
    p.fillRect( pm.rect(), colorGroup().background() );
    p.fillRect( 0, 0, 18, h-4, black );
    p.setPen( col );
    p.drawLine( 2, h/2-2, 15, h/2-2 );

    return pm;
}

QString LoadInfo::getCpuInfo()
{
	info="";
    QFile f( "/proc/cpuinfo" );
    if ( f.open( IO_ReadOnly ) )
	{
	    QTextStream ts( &f );

	    while ( !ts.atEnd() ) 
		{
			QString s = ts.readLine();
			if ( s.find( "BogoMIPS" ) == 0 ) 
			{
				info += s.mid( s.find( ':' ) + 2 );
				info += "MHz";
				//haveInfo = TRUE;
			}
		
		}
    }
    return info;
}

Load::Load( QWidget *parent, const char *name, WFlags f )
    : QWidget( parent, name, f )
{
    setMinimumHeight( 30 );
    setBackgroundColor( black );
    points = 100;
    setMinimumWidth( points );
    userLoad = new double [points];
    systemLoad = new double [points];
    for ( int i = 0; i < points; i++ ) {
	userLoad[i] = 0.0;
	systemLoad[i] = 0.0;
    }
    maxLoad = 1.3;
    QTimer *timer = new QTimer( this );
    connect( timer, SIGNAL(timeout()), SLOT(timeout()) );
    timer->start( 1000 );
    gettimeofday( &last, 0 );
    first = TRUE;
    timeout();
}

void Load::paintEvent( QPaintEvent *event )
{
    static QPixmap pixmap;
    QRect rect = event->rect();

    QSize newSize = rect.size().expandedTo(pixmap.size());
    pixmap.resize(newSize);
    //pixmap.fill(this, rect.topLeft());
    QPoint gPos=mapToGlobal(QPoint(0,0));
    bitBlt(&pixmap,0,0,QWallpaper::sysWallpaper(),gPos.x(),gPos.y(),width(),height());

    QPainter p(&pixmap, this);
    p.translate(-rect.x(), -rect.y());
    
  	p.setBrush(colorGroup().foreground());

    int h = height() - 5;

    int mult = (int)(h / maxLoad);

    p.setPen( gray );
    p.drawLine( 0, h - mult, width(), h - mult );
    p.drawText( 0, h - mult, "100" );
    p.drawText( 0, h, "0" );

    p.setPen( green );
    for ( int i = 1; i < points; i++ ) {
	int x1 = (i - 1) * width() / points;
	int x2 = i * width() / points;
	p.drawLine( x1, (int) (h - systemLoad[i-1] * mult),
		    x2, (int) (h - systemLoad[i] * mult) );
    }

    p.setPen( red );
    for ( int i = 1; i < points; i++ ) {
	int x1 = (i - 1) * width() / points;
	int x2 = i * width() / points;
	p.drawLine( x1, (int) (h - userLoad[i-1] * mult),
		    x2, (int) (h - userLoad[i] * mult) );
    }
    
    bitBlt(this, rect.x(), rect.y(), &pixmap, 0, 0, rect.width(), rect.height());
}

void Load::timeout()
{
    int user;
    int usernice;
    int sys;
    int idle;
    FILE *fp;
    fp = fopen( "/proc/stat", "r" );
    fscanf( fp, "cpu %d %d %d %d", &user, &usernice, &sys, &idle );
    fclose( fp );
    struct timeval now;
    gettimeofday( &now, 0 );
    register int tdiff = now.tv_usec - last.tv_usec;
    tdiff += (now.tv_sec - last.tv_sec) * 1000000;
    tdiff /= 10000;

    register int udiff = user - lastUser;
    register int sdiff = sys - lastSys;
    if ( tdiff > 0 ) {
	register double uload = (double)udiff / (double)tdiff;
	register double sload = (double)sdiff / (double)tdiff;
	if ( !first ) {
	    for ( int i = 1; i < points; i++ ) {
		userLoad[i-1] = userLoad[i];
		systemLoad[i-1] = systemLoad[i];
	    }
	    userLoad[points-1] = uload;
	    systemLoad[points-1] = sload;
//	    scroll( -width()/points, 0, QRect( 0, 0, width() - width()/points + 1, height() ) );
	    repaint(false);
	    double ml = 1.3;
	    /*
	    for ( int i = 0; i < points; i++ ) {
		if ( userLoad[i] > ml )
		    ml = userLoad[i];
	    }
	    */
	    if ( maxLoad != ml ) {
		maxLoad = ml;
		repaint(false);
	    }
	}

	last = now;
	lastUser = user;
	lastSys = sys;
	first = FALSE;
    } else if ( tdiff < 0 ) {
	last = now;
    }
}

double Load::getAppUsed()
{
	return userLoad[points-1]*100;
}

double Load::getSysUsed()
{
	return systemLoad[points-1]*100;
}

void LoadInfo::timeout()
{
	frequency->setText(tr("CPU frequency: ") + getCpuInfo());
	app->setText(tr("App usage: ")+QString().sprintf("%.1f%%",cpuGraph->getAppUsed()));
	sys->setText(tr("System usage: ")+QString().sprintf("%.1f%%",cpuGraph->getSysUsed()));
	//printf("app: %.1f, sys: %.1f\n",cpuGraph->getAppUsed(),cpuGraph->getSysUsed());
}

