/*************************************************************************
 * Picture: Show picture 
 * Copyright (C) 2009 Meng Zhong Die Wu <497699123@qq.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * Further, this software is distributed without any warranty that it is
 * free of the rightful claim of any third person regarding infringement
 * or the like.  Any license provided herein, whether implied or
 * otherwise, applies only to this software file.  Patent licenses, if
 * any, provided herein do not apply to combinations of this program with
 * other software, or any other product whatsoever.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
/*
 Name : Picture 
 By : Meng Zhong Die Wu
 Compile : MOTO-E6-IDE
 Time : 2009.07.26
 EMail : 497699123@qq.com
*/
#include "picture.h"
#include <ZScrollView.h>
#include <qlabel.h>
#include <qmovie.h>


Picture :: Picture( QWidget *parent , const char *name , WFlags f  )
  :QWidget( parent, name, f )
{
  w = 240;
  h = 320;
}
Picture ::~Picture()
{
}
void Picture::setPicture(QString &filename)
{
  this->setGeometry(0,0,240,320);
 
	 sv = new ZScrollView(this);
	 sv->enableClipper(true);
	 sv->setHScrollBarMode(QScrollView::Auto);

	 label = new QLabel(sv->viewport());
  
  QString fname = filename.utf8(); 
  w = QPixmap(fname).width();
  h = QPixmap(fname).height();

  if (filename.right(3).upper()=="GIF"){
    label->resize(w,h);
    label->setMovie(QMovie( filename ));
    label->setBackgroundMode(NoBackground);
    if (w>=240){
       sv->addChild(label,0,0);    	
    }else{
    	  sv->addChild(label,(240 - w)/2,(320 - h)/2); 
    }
  }else if( filename.right(3).upper()=="JPG" || filename.right(3).upper()=="JPEG" || filename.right(3).upper()=="BMP"){
    label->setBackgroundMode(NoBackground);
   	QPixmap pm;
   	QImage image( filename );
    if (pm.convertFromImage(image.smoothScale(240,320))){ 
   	  label->setPixmap(pm);
   	  label->resize(240,320); 
      if (w>=240){
        sv->addChild(label,0,0);    	
      }else{
    	   sv->addChild(label,(240 - w)/2,(320 - h)/2); 
    	 }
   }
  }else if( filename.right(3).upper()=="PNG"){
   	label->setPixmap(QPixmap( filename ));
   	label->resize(w,h); 	
    if (w>=240){
      sv->addChild(label,0,0);    	
    }else{
    	 sv->addChild(label,(240 - w)/2,(320 - h)/2); 
    }
  }
  sv->resize(240,320);
}
void Picture::closeEvent(QCloseEvent *e)
{
    e->accept();
   delete this;
}
void Picture::pwaEvent()
{
  if (pm.convertFromImage(image.smoothScale(w,h))){ 
    label->setPixmap(pm);
    label->resize(w,h); 
  }
  sv->resize(240,320);
}
void Picture::keyPressEvent(QKeyEvent *ke)
{
  if(ke->key() == 4100)
  {
    close();
   }
}
void Picture ::mousePressEvent( QMouseEvent *e)
{
  if(isTopLevel()) clickPos = e->pos();
  sv->addChild(label,30,30);	
}
void Picture::mouseReleaseEvent( QMouseEvent * e )
{
    close();
}
void Picture::mouseMoveEvent( QMouseEvent *e )
{
  if(isTopLevel())
    move( e->globalPos() - clickPos );
}
