/*
 Name : THEMES
 By : Meng Zhong Die Wu
 Compile : MOTO-E6-IDE
 Time : 2009.07.26
 EMail : 497699123@qq.com
*/
#ifndef THEMEINFO_H
#define THEMEINFO_H
#include "config.h"

#if HAVE_MODULE(MODULE_THEME)
#include <qwidget.h>

//#include <ZSkinService.h>

class UTIL_ListBox;
class QListBoxItem;

class ThemeInfo : public QWidget
{
    Q_OBJECT
public:
    ThemeInfo( QWidget *parent = 0, const char *name = 0, WFlags f = 0 );
    ~ThemeInfo();

    void ReadConfig( const QString &filename);
    void SaveConfig( const QString &filename);
private slots:
    void themeListPressed( QListBoxItem* item, const QPoint& point);
    void UseTheme();
    void InstallTheme();
    void deleteTheme();
    void slotMovieUp();
    void slotMovieDown();
    void slotImageLogo();
    void slotImageWallpaper();
    void slotSetLogo();
    void slotSetMovieUp();
    void slotSetMovieDown();
    void slotSetWallpaper();
private :
    QString SkinFile,IconDir,LogoIcon,Name,CurrentUse,WallPaper,PowerOnScreen,PowerOffScreen,BlendingColor;
    int TextSize,ColorPaletteIndex,BlendingPercentage;
private:
    QString ThemeInfo::Find(const QString &path);
    const QPixmap getThemeLogo(const QString &fileName);
    const QString getThemeName(const QString &fileName);
    void checkThemeList();
    void updateThemeList();
    void moviePreview( bool on );
    void imagePreview( bool logo );
    void setIcon(const QString &filename ,const QString &type , const QString &var);
    UTIL_ListBox *themeList;
};
#endif //HAVE_MODULE(MODULE_THEME)
#endif //THEMEINFO_H
